### Method

# Gio Socket receive_from

since: 2.22

#### Declaration [src]

    gssize
    g_socket_receive_from (
      GSocket* socket,
      GSocketAddress** address,
      gchar* buffer,
      gsize size,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Receive data (up to `size` bytes) from a socket.

If `address` is non-`NULL` then `address` will be set equal to the source address of the received packet. `address` is owned by the caller.

See `g_socket_receive()` for additional information.

Available since: 2.22

#### Parameters

`address`

  Type: `GSocketAddress`

  A pointer to a `GSocketAddress` pointer, or `NULL`.

  The argument will be set by the function.
  The argument can be `NULL`.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`buffer`

  Type: An array of `guint8`

      a buffer to read data into (which should be at least `size` bytes long).

  The argument will be set by the function.
  The length of the array is specified in the `size` argument.
  The returned data is owned by the instance.

`size`

  Type: `gsize`

  The number of bytes you want to read from the socket.

`cancellable`

  Type: `GCancellable`

  A %GCancellable or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gssize`

Number of bytes read, or 0 if the connection was closed by the peer, or -1 on error.